# coding: utf-8

import os
import sys
reload(sys)
sys.setdefaultencoding('utf-8')
import re
import ctypes
import traceback
sys.path.insert(0, os.path.dirname(traceback.extract_stack()[1][0]))
import TinyTTS
import thread
import time


PYdotDLL_GLOBAL = {} # PYdotDLL global data dictionary, all global data which is used by pydotdll is stored here

def PYdotDLL_UTILS_InlineHook(where, fake):
    if type(where) is str:
        dllname, procname = where.split('.')
        hdll = ctypes.windll.kernel32.LoadLibraryA(dllname)
        where = ctypes.windll.kernel32.GetProcAddress(hdll, procname)
    if type(where) is int:
        origin = ctypes.c_long()
        ctypes.windll.PYdotDLL.InlineHook(where, fake, ctypes.byref(origin))
        return origin.value
    return 0

def PYdotDLL_HOOK_ReturnOriginFunction(*args):
    invoker = traceback.extract_stack()[-2][2]
    global PYdotDLL_GLOBAL
    return PYdotDLL_GLOBAL['hook'][invoker][0](*args)

def PYdotDLL_HOOK_Decorator(where, functype=ctypes.WINFUNCTYPE, **kw):
    def _hook(f):
        fargs = f.func_code.co_varnames[:f.func_code.co_argcount]
        gettype = lambda x: kw.get(x, ctypes.c_ulong)
        ftype = functype(gettype('restype'), *tuple([gettype(x) for x in fargs]))
        fake = ftype(f)
        origin = PYdotDLL_UTILS_InlineHook(where, fake)
        if origin:
            origin = ftype(origin)
        global PYdotDLL_GLOBAL
        if not PYdotDLL_GLOBAL.has_key('hook'):
            PYdotDLL_GLOBAL['hook'] = {}
        PYdotDLL_GLOBAL['hook'][f.__name__] = [origin,fake]

        def AKUMA(*args, **kw):
            print 'Go home, akuma will eat you. hahaaa !!'
        return AKUMA
    return _hook

HOOKDecorator = PYdotDLL_HOOK_Decorator
OriginFuncion = PYdotDLL_HOOK_ReturnOriginFunction

# Todo:
if __name__ == '__m123ain__':
    print 'ooh! here is not entry.'
else:

    # Ensure and Open Console
    ctypes.windll.kernel32.AllocConsole()
    sys.stderr = sys.stdout = open("CONOUT$", "w")
    sys.stdin = open('CONIN$', 'r')
    print 'Test Console .'
    sys.stdout.flush()

    kernel32 = ctypes.windll.kernel32
    AbstractMsg = ctypes.CFUNCTYPE(ctypes.c_long, ctypes.c_void_p, ctypes.c_long) \
            (kernel32.GetProcAddress(kernel32.LoadLibraryA('KernelUtil'), '?GetMsgAbstract@Msg@Util@@YA?AVCTXStringW@@PAUITXMsgPack@@@Z'))

    MsgCookies = []
    IsSpeakerRunning = False

    def Speaker():
        while True:
            if MsgCookies:
                TinyTTS.SPEECH(MsgCookies.pop())
            else:
                time.sleep(1)

    @HOOKDecorator('KernelUtil.?SaveMsg@Msg@Util@@YAHPB_WKKKPAUITXMsgPack@@PAUITXData@@@Z', ctypes.CFUNCTYPE)
    def SaveMsg(str, toQQNum, fromQQNum, data3, pmsg, pdata):
        xmsg = ctypes.c_long()
        AbstractMsg(ctypes.pointer(xmsg), pmsg)
        msg = ctypes.wstring_at(xmsg.value)
        print '########### MSG ###########'
        print '[%d->%d] %s' % (fromQQNum, toQQNum, msg.encode('gb2312'))
        print ''
        sys.stdout.flush()
        MsgCookies.insert(0, '%d说: %s' % (fromQQNum, msg.encode('gb2312')))
        global IsSpeakerRunning
        if not IsSpeakerRunning:
            IsSpeakerRunning = True
            thread.start_new(Speaker, ())
        return OriginFuncion(str, toQQNum, fromQQNum, data3, pmsg, pdata)

